// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// The properties of the create certificate operation.
    /// </summary>
    public partial class CertificateCreateOrUpdateProperties
    {
        private string _base64Value;
        
        /// <summary>
        /// Required. Gets or sets the base64 encoded value of the certificate.
        /// </summary>
        public string Base64Value
        {
            get { return this._base64Value; }
            set { this._base64Value = value; }
        }
        
        private string _description;
        
        /// <summary>
        /// Optional. Gets or sets the description of the certificate.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private bool _isExportable;
        
        /// <summary>
        /// Optional. Gets or sets the is exportable flag of the certificate.
        /// </summary>
        public bool IsExportable
        {
            get { return this._isExportable; }
            set { this._isExportable = value; }
        }
        
        private string _thumbprint;
        
        /// <summary>
        /// Optional. Gets or sets the thumbprint of the certificate.
        /// </summary>
        public string Thumbprint
        {
            get { return this._thumbprint; }
            set { this._thumbprint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// CertificateCreateOrUpdateProperties class.
        /// </summary>
        public CertificateCreateOrUpdateProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// CertificateCreateOrUpdateProperties class with required arguments.
        /// </summary>
        public CertificateCreateOrUpdateProperties(string base64Value)
            : this()
        {
            if (base64Value == null)
            {
                throw new ArgumentNullException("base64Value");
            }
            this.Base64Value = base64Value;
        }
    }
}
