// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A Data Lake Analytics job data path item.
    /// </summary>
    public partial class JobDataPath
    {
        /// <summary>
        /// Initializes a new instance of the JobDataPath class.
        /// </summary>
        public JobDataPath() { }

        /// <summary>
        /// Initializes a new instance of the JobDataPath class.
        /// </summary>
        /// <param name="jobId">the id of the job this data is for.</param>
        /// <param name="command">the command that this job data relates
        /// to.</param>
        /// <param name="paths">the list of paths to all of the job
        /// data.</param>
        public JobDataPath(Guid? jobId = default(Guid?), string command = default(string), IList<string> paths = default(IList<string>))
        {
            JobId = jobId;
            Command = command;
            Paths = paths;
        }

        /// <summary>
        /// Gets the id of the job this data is for.
        /// </summary>
        [JsonProperty(PropertyName = "jobId")]
        public Guid? JobId { get; private set; }

        /// <summary>
        /// Gets the command that this job data relates to.
        /// </summary>
        [JsonProperty(PropertyName = "command")]
        public string Command { get; private set; }

        /// <summary>
        /// Gets the list of paths to all of the job data.
        /// </summary>
        [JsonProperty(PropertyName = "paths")]
        public IList<string> Paths { get; private set; }

    }
}
