// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The properties of a lab cost item.
    /// </summary>
    public partial class CostPerDayProperties
    {
        /// <summary>
        /// Initializes a new instance of the CostPerDayProperties class.
        /// </summary>
        public CostPerDayProperties() { }

        /// <summary>
        /// Initializes a new instance of the CostPerDayProperties class.
        /// </summary>
        public CostPerDayProperties(DateTime? date = default(DateTime?), double? cost = default(double?), string costType = default(string))
        {
            Date = date;
            Cost = cost;
            CostType = costType;
        }

        /// <summary>
        /// The date of the cost item.
        /// </summary>
        [JsonProperty(PropertyName = "date")]
        public DateTime? Date { get; set; }

        /// <summary>
        /// The cost component of the cost item.
        /// </summary>
        [JsonProperty(PropertyName = "cost")]
        public double? Cost { get; set; }

        /// <summary>
        /// The type of the cost. Possible values include: 'Unavailable',
        /// 'Reported', 'Projected'
        /// </summary>
        [JsonProperty(PropertyName = "costType")]
        public string CostType { get; set; }

    }
}
