// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Graph.RBAC.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Request parameters for IsMemberOf API call
    /// </summary>
    public partial class CheckGroupMembershipParameters
    {
        /// <summary>
        /// Initializes a new instance of the CheckGroupMembershipParameters
        /// class.
        /// </summary>
        public CheckGroupMembershipParameters() { }

        /// <summary>
        /// Initializes a new instance of the CheckGroupMembershipParameters
        /// class.
        /// </summary>
        /// <param name="groupId">The object ID of the group to check.</param>
        /// <param name="memberId">The object ID of the contact, group, user, or service principal to check for membership in the specified group.</param>
        public CheckGroupMembershipParameters(string groupId, string memberId)
        {
            GroupId = groupId;
            MemberId = memberId;
        }

        /// <summary>
        /// Gets or sets the object ID of the group to check.
        /// </summary>
        [JsonProperty(PropertyName = "groupId")]
        public string GroupId { get; set; }

        /// <summary>
        /// Gets or sets the object ID of the contact, group, user, or service
        /// principal to check for membership in the specified group.
        /// </summary>
        [JsonProperty(PropertyName = "memberId")]
        public string MemberId { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (GroupId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "GroupId");
            }
            if (MemberId == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "MemberId");
            }
        }
    }
}
