// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.KeyVault.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// SKU details
    /// </summary>
    public partial class Sku
    {
        /// <summary>
        /// Initializes a new instance of the Sku class.
        /// </summary>
        public Sku() { }

        /// <summary>
        /// Initializes a new instance of the Sku class.
        /// </summary>
        /// <param name="name">SKU name to specify whether the key vault is a
        /// standard vault or a premium vault. Possible values include:
        /// 'standard', 'premium'</param>
        public Sku(SkuName name)
        {
            Name = name;
        }
        /// <summary>
        /// Static constructor for Sku class.
        /// </summary>
        static Sku()
        {
            Family = "A";
        }

        /// <summary>
        /// Gets or sets SKU name to specify whether the key vault is a
        /// standard vault or a premium vault. Possible values include:
        /// 'standard', 'premium'
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public SkuName Name { get; set; }

        /// <summary>
        /// SKU family name
        /// </summary>
        [JsonProperty(PropertyName = "family")]
        public static string Family { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
