// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class X12DelimiterOverrides
    {
        /// <summary>
        /// Initializes a new instance of the X12DelimiterOverrides class.
        /// </summary>
        public X12DelimiterOverrides() { }

        /// <summary>
        /// Initializes a new instance of the X12DelimiterOverrides class.
        /// </summary>
        public X12DelimiterOverrides(string protocolVersion = default(string), string messageId = default(string), int? dataElementSeparator = default(int?), int? componentSeparator = default(int?), int? segmentTerminator = default(int?), SegmentTerminatorSuffix? segmentTerminatorSuffix = default(SegmentTerminatorSuffix?), int? replaceCharacter = default(int?), bool? replaceSeparatorsInPayload = default(bool?), string targetNamespace = default(string))
        {
            ProtocolVersion = protocolVersion;
            MessageId = messageId;
            DataElementSeparator = dataElementSeparator;
            ComponentSeparator = componentSeparator;
            SegmentTerminator = segmentTerminator;
            SegmentTerminatorSuffix = segmentTerminatorSuffix;
            ReplaceCharacter = replaceCharacter;
            ReplaceSeparatorsInPayload = replaceSeparatorsInPayload;
            TargetNamespace = targetNamespace;
        }

        /// <summary>
        /// Gets or sets the protocol version.
        /// </summary>
        [JsonProperty(PropertyName = "protocolVersion")]
        public string ProtocolVersion { get; set; }

        /// <summary>
        /// Gets or sets the message id.
        /// </summary>
        [JsonProperty(PropertyName = "messageId")]
        public string MessageId { get; set; }

        /// <summary>
        /// Gets or sets the data element separator.
        /// </summary>
        [JsonProperty(PropertyName = "dataElementSeparator")]
        public int? DataElementSeparator { get; set; }

        /// <summary>
        /// Gets or sets the component separator.
        /// </summary>
        [JsonProperty(PropertyName = "componentSeparator")]
        public int? ComponentSeparator { get; set; }

        /// <summary>
        /// Gets or sets the segment terminator.
        /// </summary>
        [JsonProperty(PropertyName = "segmentTerminator")]
        public int? SegmentTerminator { get; set; }

        /// <summary>
        /// Gets or sets the segment terminator suffix. Possible values
        /// include: 'NotSpecified', 'None', 'CR', 'LF', 'CRLF'
        /// </summary>
        [JsonProperty(PropertyName = "segmentTerminatorSuffix")]
        public SegmentTerminatorSuffix? SegmentTerminatorSuffix { get; set; }

        /// <summary>
        /// Gets or sets the replacement character.
        /// </summary>
        [JsonProperty(PropertyName = "replaceCharacter")]
        public int? ReplaceCharacter { get; set; }

        /// <summary>
        /// Gets or sets the value indicating whether to replace separators in
        /// payload.
        /// </summary>
        [JsonProperty(PropertyName = "replaceSeparatorsInPayload")]
        public bool? ReplaceSeparatorsInPayload { get; set; }

        /// <summary>
        /// Gets or sets the target namespace on which this delimiter settings
        /// has to be applied.
        /// </summary>
        [JsonProperty(PropertyName = "targetNamespace")]
        public string TargetNamespace { get; set; }

    }
}
