// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.CommitmentPlans.Models
{
    using System.Linq;

    /// <summary>
    /// Represents the association between a commitment plan and some other
    /// resource, such as a Machine Learning web service.
    /// </summary>
    public partial class CommitmentAssociation : Resource
    {
        /// <summary>
        /// Initializes a new instance of the CommitmentAssociation class.
        /// </summary>
        public CommitmentAssociation() { }

        /// <summary>
        /// Initializes a new instance of the CommitmentAssociation class.
        /// </summary>
        /// <param name="location">Resource location.</param>
        /// <param name="id">Resource Id.</param>
        /// <param name="name">Resource name.</param>
        /// <param name="type">Resource type.</param>
        /// <param name="tags">User-defined tags for the resource.</param>
        /// <param name="etag">An entity tag used to enforce optimistic
        /// concurrency.</param>
        /// <param name="properties">The properties of the commitment
        /// association resource.</param>
        public CommitmentAssociation(string location, string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), string etag = default(string), CommitmentAssociationProperties properties = default(CommitmentAssociationProperties))
            : base(location, id, name, type, tags)
        {
            Etag = etag;
            Properties = properties;
        }

        /// <summary>
        /// Gets or sets an entity tag used to enforce optimistic concurrency.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

        /// <summary>
        /// Gets or sets the properties of the commitment association resource.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties")]
        public CommitmentAssociationProperties Properties { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
