// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Represents metric limits set on a web app.
    /// </summary>
    public partial class SiteLimits
    {
        /// <summary>
        /// Initializes a new instance of the SiteLimits class.
        /// </summary>
        public SiteLimits() { }

        /// <summary>
        /// Initializes a new instance of the SiteLimits class.
        /// </summary>
        public SiteLimits(double? maxPercentageCpu = default(double?), long? maxMemoryInMb = default(long?), long? maxDiskSizeInMb = default(long?))
        {
            MaxPercentageCpu = maxPercentageCpu;
            MaxMemoryInMb = maxMemoryInMb;
            MaxDiskSizeInMb = maxDiskSizeInMb;
        }

        /// <summary>
        /// Maximum allowed CPU usage percentage
        /// </summary>
        [JsonProperty(PropertyName = "maxPercentageCpu")]
        public double? MaxPercentageCpu { get; set; }

        /// <summary>
        /// Maximum allowed memory usage in MB
        /// </summary>
        [JsonProperty(PropertyName = "maxMemoryInMb")]
        public long? MaxMemoryInMb { get; set; }

        /// <summary>
        /// Maximum allowed disk size usage in MB
        /// </summary>
        [JsonProperty(PropertyName = "maxDiskSizeInMb")]
        public long? MaxDiskSizeInMb { get; set; }

    }
}
