// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// An object describing the difference in setting values between two web
    /// app slots
    /// </summary>
    public partial class SlotDifference : Resource
    {
        /// <summary>
        /// Initializes a new instance of the SlotDifference class.
        /// </summary>
        public SlotDifference() { }

        /// <summary>
        /// Initializes a new instance of the SlotDifference class.
        /// </summary>
        public SlotDifference(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string slotDifferenceType = default(string), string settingType = default(string), string diffRule = default(string), string settingName = default(string), string valueInCurrentSlot = default(string), string valueInTargetSlot = default(string), string description = default(string))
            : base(location, id, name, type, tags)
        {
            SlotDifferenceType = slotDifferenceType;
            SettingType = settingType;
            DiffRule = diffRule;
            SettingName = settingName;
            ValueInCurrentSlot = valueInCurrentSlot;
            ValueInTargetSlot = valueInTargetSlot;
            Description = description;
        }

        /// <summary>
        /// Indicates the type of the difference: Information, Warning or
        /// Error.
        /// </summary>
        [JsonProperty(PropertyName = "properties.type")]
        public string SlotDifferenceType { get; set; }

        /// <summary>
        /// The type of the settings: General, AppSetting or ConnectionString
        /// </summary>
        [JsonProperty(PropertyName = "properties.settingType")]
        public string SettingType { get; set; }

        /// <summary>
        /// Rule that describes how to process the difference in settings
        /// during web app slot swap.
        /// </summary>
        [JsonProperty(PropertyName = "properties.diffRule")]
        public string DiffRule { get; set; }

        /// <summary>
        /// Name of the setting
        /// </summary>
        [JsonProperty(PropertyName = "properties.settingName")]
        public string SettingName { get; set; }

        /// <summary>
        /// Value of the setting in the current web app slot
        /// </summary>
        [JsonProperty(PropertyName = "properties.valueInCurrentSlot")]
        public string ValueInCurrentSlot { get; set; }

        /// <summary>
        /// Value of the setting in the target web app slot
        /// </summary>
        [JsonProperty(PropertyName = "properties.valueInTargetSlot")]
        public string ValueInTargetSlot { get; set; }

        /// <summary>
        /// Description of the difference
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
