// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Uses Java regexes to emit multiple tokens - one for each capture group
    /// in one or more patterns. This token filter is implemented using
    /// Apache Lucene.
    /// <see href="http://lucene.apache.org/core/4_10_3/analyzers-common/org/apache/lucene/analysis/pattern/PatternCaptureGroupTokenFilter.html" />
    /// </summary>
    [JsonObject("#Microsoft.Azure.Search.PatternCaptureTokenFilter")]
    public partial class PatternCaptureTokenFilter : TokenFilter
    {
        /// <summary>
        /// Initializes a new instance of the PatternCaptureTokenFilter class.
        /// </summary>
        public PatternCaptureTokenFilter() { }

        /// <summary>
        /// Initializes a new instance of the PatternCaptureTokenFilter class.
        /// </summary>
        public PatternCaptureTokenFilter(string name, IList<string> patterns, bool? preserveOriginal = default(bool?))
            : base(name)
        {
            Patterns = patterns;
            PreserveOriginal = preserveOriginal;
        }

        /// <summary>
        /// Gets or sets a list of patterns to match against each token.
        /// </summary>
        [JsonProperty(PropertyName = "patterns")]
        public IList<string> Patterns { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether to return the original
        /// token even if one of the patterns matches. Default is true.
        /// </summary>
        [JsonProperty(PropertyName = "preserveOriginal")]
        public bool? PreserveOriginal { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (Patterns == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Patterns");
            }
        }
    }
}
